
function doInfoCalculations(){
	var doInstructions=function(type){
		var baseInstructions=[red+'--------------------------------------------------------------',
			yellow+'Instructions:',
			white+'The following are all of the options available to the calculator.',
			white+'If you wish to see just the instructions for a particular type, use: calc <'+red+'type'+white+'>',
			yellow+'Example: '+white+'calc practices',
			'',
			'If you find any bugs or would like to suggest additional calculators, contact Iron in game',
			'',
			'',
		];
		var instructions={
			pool:[yellow+'--------------------------------------------------------------',
				white+'Option '+red+'pool',
				'',	
				white+'Calculates the amount of platinum it will cost to train a pool (health, mana, endurance, spirit) from one value to another.',
				yellow+'Usage: '+white+'calc pool <'+red+'desired pool'+white+'>  <'+red+'current pool'+white+'>  <'+red+'current platinum cost'+white+'>',
				yellow+'Usage: '+white+'calc pool <'+red+'desired pool'+white+'>  <'+red+'current pool'+white+'>  <'+red+'current experience cost'+white+'>  <'+red+'current platinum cost'+white+'>',
				yellow+'Note: '+red+'['+white+' and '+red+'] '+white+'are ignored in argument list, so you can copy paste from the "train" list in Nodeka. Adding the experience value yields additional information.',				
				yellow+'Example: Typing in the numbers manually',
				white+'calc pool 20000 10000 352',
				yellow+'Example: Copying from the "train" list in Nodeka',
				white+'calc pool 20000 13075     ]  [ 70412500   ]  [     387      ]',
				'',				
				''
			],
			practices:[yellow+'--------------------------------------------------------------',
				white+'Option '+red+'practices',
				'',	
				white+'Calculates the amount of platinum it will cost to train a skill from one % to another % or how much X amount of platinum will increase a skill',
				yellow+'Usage: '+white+'calc practices <'+red+'current skill %'+white+'>  <'+red+'desired skill %'+white+'>',
				yellow+'Usage: '+white+'calc practices <'+red+'current skill %'+white+'>  <'+red+'platinum to spend'+white+'>',
				yellow+'Example: % to %',
				white+'calc practices 100 200',
				yellow+'Example: % by platinum',
				white+'calc practices 100 350000',
				'',				
				''
			],
			stats:[yellow+'--------------------------------------------------------------',
				white+'Option '+red+'stats',
				'',	
				white+'Calculates the cost of enhancing a stat (str, int, con, etc).  This assumes the player is a major remort for costs.',
				yellow+'Note: '+white+'If no second value is used, then 270 (max enhance value) is assumed.  Any end value greater than 270 will be automatically reduced to 270.',
				yellow+'Note: '+white+'Augmenting removes stats by the following formula: aug 1-19 = 300-((aug level+2)*10). So getting aug 7 will cost 90 stats.  Aug 20+ all take the stat down to 100.',
				yellow+'Usage: '+white+'calc stats <'+red+'Start value (1-269)'+white+'> <'+red+'end value(2-270)'+white+'>',
				yellow+'Usage: '+white+'calc stats <'+red+'Start value'+white+'>',
				yellow+'Example: start to end',
				white+'calc stats 137 240',
				yellow+'Example: start to 270',
				white+'calc stats 137',
				'',				
				''
			]
		}
		if(!type || (!(type in instructions))){
			doOutput(baseInstructions);
			for(var x in instructions){
				doOutput(instructions[x]);
			}
		}
		else{
			doOutput(instructions[type]);
		}		
	};
	// text = array of strings.  Each string will be output as a line
	var doOutput=function(text, capture){
		if(capture){
			umc.capture(yellow+'------------------------------------------------------');
		}
		for(var x=0; x<text.length; x++){
			if(capture){
				umc.capture(text[x]);
			}
			else{
				umc.print(text[x]);
			}
		}
		if(capture){
			umc.capture(yellow+'------------------------------------------------------');
		}
		umc.parse('#cr');
	}
	var formatNumber=function(val){
		val=val.toString();
		var y=0;
		var res='';
		for(var x=val.length-1; x>=0; x--){
			res=val[x]+res;
			y++;
			if(y==3&&x>0){
				res=','+res;
				y=0;
			}				
		}
		return res;		
	};
	var _NL='\n\r';
	var red=(new String(umc.getVar('UMC_LIGHTRED').toString()));
	var white=(new String(umc.getVar('UMC_WHITE').toString()));
	var yellow=(new String(umc.getVar('UMC_YELLOW').toString()));
	var endColor=red[0]+'[0m';
	var output=null;
	
	var params=[];
	for(var x=0; x<arguments.length; x++){
		var arg=(new String(arguments[x])).replace(/\033\[[0-9;]+\w/g, "").replace(/^(\s*)/,"").replace(/(\s*)$/,"");
		if(arg!='[' && arg!=']' && arg!='' && arg!=null && arg!=undefined && arg!='undefined'){
			params.push(arg);
		}
	}	
	if(params.length==0 || params[0]==''){
		doInstructions();
		return;
	}
	params[0]=params[0].toLowerCase();
	for(var x=1; x<params.length; x++){
		params[x]=parseInt(params[x]);
	}
	if(params[params.length-1]==''||params[params.length-1]==null){
		params.pop();
	}
	if(params[0]=='pool'){
		var platStep=4;
		var endPool=params[1];
		var startPool=params[2];
		var realStart=startPool;
		var realEnd=endPool;
		var platCost=0;
		var expCost=0;
		var doExp=false;
		if(params[3]>10000){
			platCost=params[4];
			expCost=params[3];
			doExp=true;
		}else{
			platCost=params[3];
		}
		var startPool=Math.floor(startPool/10)*10;
		var endPool=Math.floor(endPool/10)*10;
		var currentPool=startPool;
		var totalPlat=0;
		var count=0;
		var numTrains=0;
		var output=null;
		var startTrainCount=0;
		var endTrainCount=0;
		if(doExp){
			startTrainCount=Math.floor(2000000000/expCost);
		}	
		if(isNaN(startPool)||isNaN(endPool)||isNaN(platCost)||(startPool<10)||startPool>endPool||platCost<1){
			doInstructions('pool');
		}
		else{
			var loopCount=4;
			var loop=1;
			while(currentPool<endPool){
				numTrains++;
				currentPool+=10;
				totalPlat+=platCost;
				expCost+=55000;
				count++;
				if(count==loopCount){
					loop++;
					if(loop==5){
						loopCount=5;
						loop=1;
					}
					else{
						loopCount=4;
					}
					platCost++;
					count=0;					
				}
			}
			output=[white+'To train from '+red+formatNumber(realStart)+white+' to '+red+formatNumber(realEnd)+white+':',
				white+'You will need to train '+red+formatNumber(numTrains)+white+' times',
				white+'It will cost  approximately '+red+formatNumber(totalPlat)+white+' platinum',
				white+'The next train will cost approximately '+red+formatNumber(platCost)+white+' platinum'
			];
			if(doExp){
				endTrainCount=Math.floor(2000000000/expCost);
				output.push('The next train will cost '+red+formatNumber(expCost)+white+' experience');
				output.push(white+'You will be able to train '+red+formatNumber(startTrainCount)+white+' times per experience cap when you start training');
				output.push(white+'You will be able to train '+red+formatNumber(endTrainCount)+white+' times per experience cap when you finish training');
			}
			else{
				output.push(white+'No experience information provided');
			}
			doOutput(output,true);
		}		
	}
	else if(params[0]=='practices'){
		var start=params[1];
		var end=params[2];		
		var numPracs=0;
		var plats=0;
		var stones=0;
		if(isNaN(start)||isNaN(end)||(start>=end)||(start<0)){
			doInstructions('practices');
		}
		else{
			if(end<=605){
				for(var x=start+1; x<=end; x++){
					numPracs+=x;
				}
				var plats=Math.ceil(numPracs/100)*5000;
				var stones=Math.ceil(numPracs/400);
				output=[white+'To practice from '+red+start+white+' to '+red+end+white+', it will cost:',
					yellow+'Practices: '+white+formatNumber(numPracs),
					yellow+'Platinum: '+white+formatNumber(plats),
					yellow+'Sun Stones: '+white+formatNumber(stones)
				]
			}
			else{
				var curSkill=start;
				var plats=end;
				var numPracs=Math.floor(plats/5000)*100;
				var pracCount=numPracs;
				while(pracCount>=0){
					curSkill++;
					pracCount-=curSkill;
				}
				output=[red+formatNumber(plats)+white+' platinum will buy you '+red+formatNumber(numPracs)+white+' practices.',
					white+'You can train your skill to '+red+(curSkill-1)+white+'% and have '+red+(pracCount+curSkill)+white+' practices left over.'
				]
			}
			doOutput(output, true);
		}
		
	}
	else if(params[0]=='stats'){
		if(isNaN(params[1])|| params[1]>270 || params[1]<1){
			doInstructions('stats');
		}
		else{
			var end=params[2]||270;
			if(end>270){
				end=270;
			}
			var start=params[1];
			var total=0;
			for(var x=start; x<end; x++){
				if(x<=100){
					total+=450;
				}
				else if(x<=200){
					total+=450+x*2
				}
				else if(x<300){
					total+=450+x*3;
				}
			}
			var output=[white+'To enhance from '+red+start+white+' to '+red+end+white+', it will cost '+red+total+white+' Platinum'];
			doOutput(output,true);
		}
	}
	else{
		doInstructions();
	}
}

